
@js
	var openMenu, lastMenuTarget
	, tooltip = El("pre.tooltip").to(document.body)
	El.near = near
	function near(source, target, x, y, margin) {
		var top, left
		, rect = target.getBoundingClientRect()
		if (x == "left") {
			left = rect.left - (source.offsetWidth) - margin
			x = "150%"
		} else if (x == "leftEdge") {
			left = rect.left - margin
			x = "0%"
		} else if (x == "right") {
			left = rect.left + target.offsetWidth + margin
			x = "-50%"
		} else if (x == "rightEdge") {
			left = rect.left - source.offsetWidth + target.offsetWidth + margin
			x = "100%"
		} else {
			left = rect.left + (target.offsetWidth/2) - (source.offsetWidth/2)
			x = "50%"
		}
		if (y == "top") {
			top = rect.top - (source.offsetHeight) - margin
			y = " 150%"
		} else if (y == "bottom") {
			top = rect.top + target.offsetHeight + margin
			y = " -50%"
		} else {
			top = rect.top + (target.offsetHeight/2) - (source.offsetHeight/2)
			y = " 50%"
		}
		left += El.scrollLeft()
		top += El.scrollTop()
		source.css("transform-origin", x + y)
		source.css("top", (top < 0 ? 0 : top) + "px")
		source.css("left", (left < 0 ? 0 : left) + "px")
	}
	document.body.on("mouseover", function(e) {
		var x, y
		, target = e.target
		, text = target.getAttribute("data-tooltip")
		tooltip.rmClass("is-visible")
		if (!text) return
		tooltip.empty().append(text)
		if (target.hasClass("tooltip--left")) {
			x = "left"
		} else if (target.hasClass("tooltip--right")) {
			x = "right"
		} else if (target.hasClass("tooltip--top")) {
			y = "top"
		} else {
			y = "bottom"
		}
		near(tooltip, target, x, y, 4)
		setTimeout(function() {
			tooltip.addClass("is-visible")
		}, 0)
	})
	function closeMenu() {
		console.log("closeMenu", arguments)
		if (openMenu) {
			openMenu.kill()
			openMenu = null
		}
	}
	Mediator.on("resize", closeMenu)
	Mediator.on("showMenu", function(target, menu, x, y, margin, e) {
		Event.stop(e)
		console.log("showMenu", arguments)
		var close = openMenu && lastMenuTarget == target
		closeMenu()
		if (close) return
		lastMenuTarget = target
		openMenu = El(menu).to(document.body).render()
		near(openMenu, target, x, y, 4)
		setTimeout(function() {
			openMenu.addClass("is-visible")
		}, 0)
	})
	document.body.on("click", closeMenu)
@css
	.mat-Menu,
	.tooltip {
		font-family: "Roboto", "Helvetica", "Arial", sans-serif;
		border-radius: 2px;
		position: absolute;
		margin: 0;
		opacity: 0;
		transform: scale(0);
	}
	.tooltip {
		padding: 8px;
		color: #fff;
		background: #666;
		font-size: 10px;
		font-weight: 500;
		line-height: 14px;
		max-width: 170px;
		text-align: center;
		pointer-events: none;
		z-index: 9;
	}
	.mat-Menu {
		color: #000;
		background: #fff;
		font-size: 14px;
		font-weight: 400;
		letter-spacing: 0;
		list-style: none;
		padding: 8px 0;
		min-width: 124px;
		z-index: 8;
		text-align: left;
	}
	.mat-Menu-item {
		padding: 0 16px;
		display: block;
		border: none;
		margin: 0;
		outline-color: #bdbdbd;
		position: relative;
		overflow: hidden;
		text-decoration: none;
		cursor: pointer;
		height: 48px;
		line-height: 48px;
		white-space: nowrap;
	}
	.mat-Menu-item:hover {
		background-color: #eee;
	}
	.mat-Menu-item[disabled] {
		color: #bdbdbd;
		background-color: transparent;
		cursor: auto;
	}
	.mat-Menu-item.is-divider {
		border-bottom: 1px solid rgba(0,0,0,.12);
	}
	.mat-Menu.is-visible,
	.tooltip.is-visible {
		transform: scale(1);
		opacity: 1;
		transition: opacity, transform .2s cubic-bezier(0, 0, .2, 1) 0s;
	}

@js
	var tick, wait
	, ripple = El(".waves-ripple")
	document.body.on("mousedown", function(e) {
		var target = e.target
		if (!target.hasClass("waves") || target.disabled) return
		var rect = target.getBoundingClientRect()
		, top = e.clientY - rect.top
		, left = e.clientX - rect.left
		, maxH = Math.max(top, target.offsetHeight - top)
		, maxW = Math.max(left, target.offsetWidth - left)
		, max = Math.sqrt(maxH * maxH + maxW * maxW)
		, size = (2 * max) + "px"
		ripple.css("top", (top - max) + "px")
		ripple.css("left", (left - max) + "px")
		ripple.css("width", size)
		ripple.css("height", size)
		ripple.to(target)
		clearTimeout(tick)
		end()
		wait = 1
		tick = setTimeout(end, 450)
		document.body.one("mouseup", end)
		setTimeout(function() {
			ripple.addClass("waves-ripple--play")
		}, 0)
	})
	function end() {
		if (!(wait--)) {
			ripple.rmClass("waves-ripple--play")
		}
	}

@css
	.waves {
		position: relative;
		overflow: hidden;
	}
	.waves-ripple {
		position: absolute;
		border-radius: 50%;
		background-color: #000;
		opacity: 0;
		transform: scale(0);
		transition: opacity .4s cubic-bezier(0, 0, .2, 1) 0ms, transform 0s cubic-bezier(0, 0, .2, 1) .4s;
		pointer-events: none;
	}
	.waves-ripple--play {
		opacity: .4;
		transform: scale(1);
		transition: opacity .8s cubic-bezier(0, 0, .2, 1) 0ms, transform .4s cubic-bezier(0, 0, .2, 1) 0ms;
	}
	.shadow-1 {
		box-shadow: 0 2px 2px 0 rgba(0,0,0,.14),0 3px 1px -2px rgba(0,0,0,.2),0 1px 5px 0 rgba(0,0,0,.12);
	}
	.Button,
	.Fab,
	.material {
		font-family: "Roboto", "Helvetica", "Arial", sans-serif;
		font-size: 14px;
		font-weight: 500;
		position: relative;
		text-transform: uppercase;
		transition: all .2s cubic-bezier(.4,0,.2,1);
	}
	.Button,
	.Button:disabled:hover {
		background: transparent;
		border: none;
		min-width: 64px;
		height: 36px;
		line-height: 36px;
		border-radius: 2px;
		padding: 0 16px;
		letter-spacing: 0;
		text-align: center;
	}
	.Button.raised,
	.Button:hover {
		background-color: rgba(158,158,158, 0.20);
	}
	.Button:focus {
		background-color: rgba(0,0,0, 0.12);
	}
	.raised:focus:not(:active) {
		box-shadow: 0 0 8px rgba(0,0,0,.18),0 8px 16px rgba(0,0,0,.36);
	}
	.Button:disabled {
		color: #aaa;
		background: transparent;
	}
	.Fab {
		border: none;
		border-radius: 50%;
		font-size: 24px;
		height: 56px;
		line-height: 56px;
		width: 56px;
		padding: 0;
		background: rgba(158,158,158,.2);
	}
	.Button.is-warning,
	.Fab--red {
		color: #fff;
		background-color: rgb(255,87,34);
	}
	.Button.is-warning>.waves-ripple,
	.Fab--red>.waves-ripple {
		background-color: #fff;
	}
	.Fab--red>.waves-ripple--play {
		opacity: .6;
	}
	.raised {
		box-shadow: 0 1px 1.5px 0 rgba(0,0,0,.12),0 1px 1px 0 rgba(0,0,0,.24);
	}
	.Checkbox {
		display: block;
	}
	.Checkbox-icon {
		display: block;
		height: 56px;
		line-height: 56px;
		width: 56px;
	}

@el Checkbox
	label[class=Checkbox].waves
		input[type=checkbox].hidden
		i.Checkbox-icon

@el Button
	button[type=button].Button.waves Button

@el Fab
	button[type=button].Fab.waves.raised



